package domdemos;

import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class DOMDemos {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        Document doc = db.parse("file:dom.xml");
        traverse(0, doc);
    }

    private static void traverse(int depth, Node node) {
        indent(depth);
        System.out.println("type=" + node.getNodeType()
                + " name=" + node.getNodeName() + " value=" + node.getNodeValue());
        if (node instanceof Element) {
            indent(depth);
            System.out.println("===begin attributes===");
            Element elt = (Element) node;
            NamedNodeMap atts = elt.getAttributes();
            for (int i = 0; i < atts.getLength(); i++) {
                traverse(depth + 1, atts.item(i));
            }
            indent(depth);
            System.out.println("===end attributes===");
        }
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); i++) {
            traverse(depth + 1, children.item(i));
        }
    }

    private static void indent(int depth) {
        for (int i = 0; i < depth; i++) {
            System.out.print("   ");
        }
    }
}
